Attribute VB_Name = "INI"
Option Explicit
Public Declare Function GetPrivateProfileStringByKeyName& Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName$, ByVal lpszKey$, ByVal lpszDefault$, ByVal lpszReturnBuffer$, ByVal cchReturnBuffer&, ByVal lpszFile$)
Public Declare Function GetPrivateProfileStringKeys& Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName$, ByVal lpszKey&, ByVal lpszDefault$, ByVal lpszReturnBuffer$, ByVal cchReturnBuffer&, ByVal lpszFile$)
Public Declare Function GetPrivateProfileStringSections& Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName&, ByVal lpszKey&, ByVal lpszDefault$, ByVal lpszReturnBuffer$, ByVal cchReturnBuffer&, ByVal lpszFile$)
' This first line is the declaration from win32api.txt
Public Declare Function WritePrivateProfileStringByKeyName& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String)
Public Declare Function WritePrivateProfileStringToDeleteKey& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Long, ByVal lplFileName As String)
'Public Declare Function WritePrivateProfileStringToDeleteSection& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Long, ByVal lpString As Long, ByVal lplFileName As String)
'Public Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long

'WriteKey "section", "param", "value", iniFileName
'value = VBGetPrivateProfileString("section", "param", iniFileName)

Function VBGetPrivateProfileString(section As String, Key As String, file As String, Optional ByRef SameStr As String) As String

Dim KeyValue As String
Dim characters As Long

'KeyValue = String$(1024, 0)
KeyValue = AllocString_ADV(1025)

characters = GetPrivateProfileStringByKeyName(section, Key, "=", KeyValue, 1024, file)
'Debug.Print Asc(KeyValue)
If (AscW(KeyValue) = 0) Or (Left$(KeyValue, 1) = "=") Then     '  
    VBGetPrivateProfileString = SameStr
    Exit Function
End If

If characters > 0 Then
    KeyValue = Left(KeyValue, characters)
End If

VBGetPrivateProfileString = KeyValue

End Function


Public Function GetSectionNames(FileName As String, SectionNames() As String) As Integer
'GetSectionNames Return Number of Section in file
'SectionNames return all section names

Dim characters As Long
Dim SectionList As String
Dim ArrSection() As String
Dim i As Integer
Dim NullOffset As Integer

SectionList = String(1025, 0)    '128

' Retrieve the list of keys in the section
characters = GetPrivateProfileStringSections(0, 0, "", SectionList, 1024, FileName)    '127

' Load sections into Arrey
i = 0
Do
    NullOffset = InStr(SectionList, vbNullChar)
    If NullOffset > 1 Then
        ReDim Preserve ArrSection(i)
        ArrSection(i) = Mid(SectionList, 1, NullOffset - 1)
        SectionList = Mid(SectionList, NullOffset + 1)
        i = i + 1
    End If
Loop While NullOffset > 1
GetSectionNames = i - 1
SectionNames = ArrSection

End Function

Public Function GetKeyNames(SectionName As String, FileName As String, KeyNames As Variant) As Integer
'GetKeyNames Return Number of key in section  -1
'KeyNames Return list of keyNames in section 

Dim characters As Long
Dim KeyList As String
Dim ArrName() As String
Dim NullOffset As Integer
Dim i As Integer

KeyList = String(1025, 0)
' Retrieve the list of keys in the section

characters = GetPrivateProfileStringKeys(SectionName, 0, "", KeyList, 1024, FileName)

' Load Keys into Arrey
i = 0
Do
    NullOffset = InStr(KeyList, vbNullChar)
    If NullOffset > 1 Then
        ReDim Preserve ArrName(i)
        ArrName(i) = Mid(KeyList, 1, NullOffset - 1)
        KeyList = Mid(KeyList, NullOffset + 1)
        i = i + 1
    End If
Loop While NullOffset > 1
GetKeyNames = i - 1
KeyNames = ArrName

End Function

Public Function DeleteKey(KeyName As String, SectionName As String, FileName As String) As Long
'Return 0 if Deletion not sucsesful    ( )
' Delete the selected key
DeleteKey = WritePrivateProfileStringToDeleteKey(SectionName, KeyName, 0, FileName)
End Function

Public Function WriteKey(SectionName As String, KeyName As String, KeyValue As String, FileName As String) As Long
If Len(KeyValue) = 0 Then KeyValue = vbNullString
WriteKey = WritePrivateProfileStringByKeyName(SectionName, KeyName, KeyValue, FileName)
End Function

'Public Function WriteSection(SectionName As String, filename As String) As Long
'    WriteSection = WritePrivateProfileSection(SectionName, "", filename)
'End Function
'
'Public Function DeleteSection(SectionName, filename) As Long
'    DeleteSection = WritePrivateProfileStringToDeleteSection(SectionName, 0&, 0&, filename)
'End Function




