Attribute VB_Name = "module"
Option Explicit

Public ImArr() As StdPicture    'load from file
Public LastPath As String

Public Declare Function MoveWindow& Lib "user32" (ByVal hWnd As Long, _
                                                  ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, _
                                                  ByVal nHeight As Long, ByVal bRepaint As Long)

Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
'Public Declare Function AddFontResource Lib "gdi32.dll" Alias "AddFontResourceA" (ByVal lpFileName As String) As Long
'Public Declare Function RemoveFontResource Lib "gdi32.dll" Alias "RemoveFontResourceA" (ByVal lpFileName As String) As Long

Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function SysAllocStringByteLen Lib "oleaut32" (ByVal olestr As Long, ByVal bLen As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (dst As Any, src As Any, ByVal nBytes As Long)
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * 260
    cAlternate As String * 14
End Type
Public Declare Function FindFirstFile _
                         Lib "kernel32" Alias "FindFirstFileA" ( _
                             ByVal lpFileName As String, _
                             lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Private Declare Function LoadLibraryA Lib "kernel32.dll" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32.dll" (ByVal hLibModule As Long) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (iccex As InitCommonControlsExStruct) As Boolean
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Type InitCommonControlsExStruct
    lngSize As Long
    lngICC As Long
End Type
Public Function Bin2Dec(Num As String) As Double
Dim n As Long, a As Integer, X As String
n = Len(Num) - 1
a = n
Do While n > -1
    X = Mid(Num, ((a + 1) - n), 1)
    Bin2Dec = IIf((X = "1"), Bin2Dec + (2 ^ (n)), Bin2Dec)
    n = n - 1
Loop
End Function
Public Function Bin2Hex(ByVal BinaryString As String) As String
Dim X As Integer
Const BinValues = "*0000*0001*0010*0011" & _
      "*0100*0101*0110*0111" & _
      "*1000*1001*1010*1011" & _
      "*1100*1101*1110*1111*"
Const HexValues = "0123456789ABCDEF"
If BinaryString Like "*[!01]*" Then
    Bin2Hex = vbNullString
Else
    BinaryString = String$((4 - Len(BinaryString) _
                            Mod 4) Mod 4, "0") & BinaryString
    For X = 1 To Len(BinaryString) - 3 Step 4
        Bin2Hex = Bin2Hex & Mid$(HexValues, _
                                 (4 + InStr(BinValues, "*" & _
                                                       Mid$(BinaryString, X, 4) & "*")) \ 5, 1)
    Next
End If
End Function

Public Function RemoveXtraSpaces(strVal As String) As String
Do While InStr(1, strVal, vbCrLf)
    strVal = Replace(strVal, vbCrLf, "")
Loop
Do While InStr(1, strVal, " ")
    strVal = Replace(strVal, " ", "")
Loop
RemoveXtraSpaces = StrConv(strVal, vbUpperCase)
End Function

Public Function Hex2Bin(ByVal sHex As String, Optional ByteSep As String) As String
Dim arNibs() As String, i As Long, j As Long

arNibs = Split("0000,0001,0010,0011,0100,0101,0110,0111," & _
               "1000,1001,1010,1011,1100,1101,1110,1111", ",")
'-- convert each Hex digit to nibble and add byte separator if required
For i = 1 To Len(sHex)
    If sHex Like "*[!(0-9)ABCDEFabcdef]*" Then
        Hex2Bin = "Error input"
        Exit Function
    End If
    j = CLng("&H" & Mid$(sHex, i, 1))
    Hex2Bin = Hex2Bin & ByteSep & arNibs(j)
Next
'    If Len(ByteSep) Then '-- remove extra leading separator
'        Hex2Bin = Mid$(Hex2Bin, Len(ByteSep) + 1)
'    Else '-- remove leading 0's
'        i = InStr(Hex2Bin, "1")
'        If i > 1 Then Hex2Bin = Mid$(Hex2Bin, i)
'    End If
End Function
Public Function dec2binByte(ByVal DecNum As Long) As String

Select Case DecNum
Case Is > 1
    dec2binByte = dec2binByte(DecNum \ 2) & CStr(DecNum And 1)
Case Is > 0
    dec2binByte = "1"
Case Else
    dec2binByte = "0"
End Select

dec2binByte = Right("00000000" & dec2binByte, 8)
End Function
Public Function dec2bin(mynum As Long, Optional nBytes As Integer = 8) As String
Dim s As String
Dim loopcounter As Integer

Do
    If (mynum And 2 ^ loopcounter) = 2 ^ loopcounter Then
        dec2bin = "1" & dec2bin
    Else
        dec2bin = "0" & dec2bin
    End If
    loopcounter = loopcounter + 1
Loop Until 2 ^ loopcounter > mynum

s = Space$(nBytes)
s = Replace(s, " ", "0")
dec2bin = Right(s & dec2bin, nBytes)

End Function
'Public Function Dec2Hex(ByVal strDec As String) As String
'Dim mybyte(0 To 19) As Byte
'Dim lp As Long
'
'If strDec = 0 Then Dec2Hex = "00": Exit Function
'CopyMemory mybyte(0), ByVal VarPtr(CDec(strDec)), 16
'
'' Quick reorganise so we can then just step through the entire thing in one loop
'For lp = 7 To 4 Step -1
'    mybyte(12 + lp) = mybyte(lp)
'Next
'
'' Build the hex string
'For lp = 19 To 8 Step -1
'    If (Not Len(Dec2Hex) And mybyte(lp) <> 0) Or Len(Dec2Hex) Then
'        Dec2Hex = Dec2Hex & right("0" & Hex(mybyte(lp)), 2)    'IIf(Len(Dec2Hex), "00", "0"))
'    End If
'Next
'End Function
Public Function AllocString_ADV(ByVal lSize As Long) As String
RtlMoveMemory ByVal VarPtr(AllocString_ADV), _
              SysAllocStringByteLen(0&, lSize + lSize), 4&
End Function
Public Function GetNameExt(ByVal sThePathAndName As String) As String
' Return a string containing the file name from a fully qualified file name. Larry
' If no path then return the file name anyhow
Dim sTemp1 As String                        'temporary string
Dim sTemp2 As String
sTemp1 = Trim$(sThePathAndName)             'save it
sTemp2 = GetPathFromPathAndName(sTemp1)     'get path
If InStrB(sThePathAndName, sTemp2) <> 0 Then
    sTemp1 = Mid$(sThePathAndName, Len(sTemp2) + 1)
End If
GetNameExt = sTemp1             'now contains just file name
End Function
Public Function GetName(ByVal sThePathAndName As String) As String
' Return a string containing the file name from a fully qualified file name. Larry
' If no path then return the file name anyhow
Dim ret As Integer
Dim sTemp1 As String                        'temporary string
Dim sTemp2 As String
sTemp1 = Trim$(sThePathAndName)             'save it
sTemp2 = GetNameExt(sTemp1)     'get name+ext
ret = InStrRev(sTemp2, ".")
sTemp1 = Left(sTemp2, ret - 1)
GetName = sTemp1             'now contains just file name
End Function
Public Function pLoadDialog(Optional DTitle As String, Optional ByRef FileTitle As String) As String
Dim cd As cCommonDialog
Dim sfile As String
Dim indir As String

If Len(LastPath) = 0 Then
    indir = App.Path
Else
    indir = LastPath
End If
'DoEvents
Set cd = New cCommonDialog
'sfile = FileName

If (cd.VBGetOpenFileName( _
    sfile, _
    FileTitle, _
    ReadOnly:=True, _
    HideReadOnly:=True, _
    Filter:="Binary files |*.bin|All Files (*.*)|*.*", _
    FilterIndex:=1, _
    InitDir:=indir, _
    DlgTitle:=DTitle, _
    DefaultExt:="", _
    Owner:=frmmain.hWnd)) Then
    pLoadDialog = sfile
End If

Set cd = Nothing
End Function
Public Function fLoadDialog(Optional DTitle As String, Optional ByRef FileTitle As String) As String
Dim cd As cCommonDialog
Dim sfile As String
Dim indir As String

If Len(LastPath) = 0 Then
    indir = App.Path
Else
    indir = LastPath
End If
'DoEvents
Set cd = New cCommonDialog
'sfile = FileName

If (cd.VBGetOpenFileName( _
    sfile, _
    FileTitle, _
    ReadOnly:=True, _
    HideReadOnly:=True, _
    Filter:="Font files |*.ttf|All Files (*.*)|*.*", _
    FilterIndex:=1, _
    InitDir:=indir, _
    DlgTitle:=DTitle, _
    DefaultExt:="", _
    Owner:=frmmain.hWnd)) Then
    fLoadDialog = sfile
End If

Set cd = Nothing
End Function

Public Function BMPLoadDialog(Optional DTitle As String, Optional ByRef FileTitle As String) As String
Dim cd As cCommonDialog
Dim sfile As String
Dim indir As String

If Len(LastPath) = 0 Then
    indir = App.Path
Else
    indir = LastPath
End If
'DoEvents
Set cd = New cCommonDialog
'sfile = FileName

If (cd.VBGetOpenFileName( _
    sfile, _
    FileTitle, _
    ReadOnly:=True, _
    HideReadOnly:=True, _
    Filter:="BMP files |*.bmp|All Files (*.*)|*.*", _
    FilterIndex:=1, _
    InitDir:=indir, _
    DlgTitle:=DTitle, _
    DefaultExt:="", _
    Owner:=frmmain.hWnd)) Then
    BMPLoadDialog = sfile
End If

Set cd = Nothing
End Function

Public Function GetPathFromPathAndName(ByVal sThePathAndName As String) As String
' Return a string containing the file's path from a fully qualified file name. Larry
' Return "" if no path
Dim i As Integer                    'used in for/next loops
Dim sTemp As String

sTemp = Trim$(sThePathAndName)      'trim it
If InStrB(sTemp, "\") = 0 Then       'any backslash?
    Exit Function
End If
For i = Len(sTemp) To 1 Step -1     'find the right most one
    If Mid$(sTemp, i, 1) = "\" Then
        GetPathFromPathAndName = Mid$(sTemp, 1, i)    'now have just path
        Exit Function
    End If
Next
End Function

'Public Function pSaveDialog(Optional DTitle As String, Optional myFileName As String) As String
'
'Dim cd As cCommonDialog
'Dim sfile As String
'Dim fTitle As String
'
'Set cd = New cCommonDialog
''sfile = FileName
''DoEvents
'If (cd.VBGetSaveFileName( _
  '    sfile, _
  '    fTitle, _
  '    Filter:="Binary files |*.bin|All Files (*.*)|*.*", _
  '    FilterIndex:=1, _
  '    DlgTitle:=DTitle, _
  '    DefaultExt:="bin", _
  '    Owner:=frmmain.hwnd)) Then
'    pSaveDialog = sfile
'End If
'
'Set cd = Nothing
'End Function
'

Public Function intBytes(nBits As Integer) As Integer
'ret 8,16,24...
intBytes = 8
Do While intBytes / nBits < 1
    intBytes = intBytes + 8
Loop

End Function
Private Sub Main()
Dim iccex As InitCommonControlsExStruct, hMod As Long
' constant descriptions: http://msdn.microsoft.com/en-us/library/bb775507%28VS.85%29.aspx
'Const ICC_ANIMATE_CLASS As Long = &H80&
'Const ICC_BAR_CLASSES As Long = &H4&
'Const ICC_COOL_CLASSES As Long = &H400&
'Const ICC_DATE_CLASSES As Long = &H100&
'Const ICC_HOTKEY_CLASS As Long = &H40&
'Const ICC_INTERNET_CLASSES As Long = &H800&
'Const ICC_LINK_CLASS As Long = &H8000&
'Const ICC_LISTVIEW_CLASSES As Long = &H1&
'Const ICC_NATIVEFNTCTL_CLASS As Long = &H2000&
'Const ICC_PAGESCROLLER_CLASS As Long = &H1000&
'Const ICC_PROGRESS_CLASS As Long = &H20&
'Const ICC_TAB_CLASSES As Long = &H8&
'Const ICC_TREEVIEW_CLASSES As Long = &H2&
'Const ICC_UPDOWN_CLASS As Long = &H10&
'Const ICC_USEREX_CLASSES As Long = &H200&
Const ICC_STANDARD_CLASSES As Long = &H4000&
'Const ICC_WIN95_CLASSES As Long = &HFF&
'Const ICC_ALL_CLASSES As Long = &HFDFF&    ' combination of all values above

With iccex
    .lngSize = LenB(iccex)
    .lngICC = ICC_STANDARD_CLASSES    ' vb intrinsic controls (buttons, textbox, etc)
' if using Common Controls; add appropriate ICC_ constants for type of control you are using
' example if using CommonControls v5.0 Progress bar:
' .lngICC = ICC_STANDARD_CLASSES Or ICC_PROGRESS_CLASS
End With

On Error Resume Next    ' error? InitCommonControlsEx requires IEv3 or above

hMod = LoadLibraryA("shell32.dll")    ' patch to prevent XP crashes when VB usercontrols present
InitCommonControlsEx iccex
If Err Then
    InitCommonControls    ' try Win9x version
    Err.Clear
End If

On Error GoTo 0

'... show your main form next (i.e., Form1.Show)
frmmain.Show
If hMod Then FreeLibrary hMod


'** Tip 1: Avoid using VB Frames when applying XP/Vista themes
'          In place of VB Frames, use pictureboxes instead.
'          'bug' may no longer apply to Win7+
'** Tip 2: Avoid using Graphical Style property of buttons, checkboxes and option buttons
'          Doing so will prevent them from being themed.
End Sub

Public Function SplitToLines(hdcObject As Object, ByVal sText As String, _
                             ByVal lLength As Long, Optional ByVal bFilterLines As Boolean = True) As String()

Dim mArray() As String
Dim mChar As String
Dim mLine As String
Dim lnCount As Long
Dim xMax As String
Dim mPos As Long
Dim X As Long
Dim lDone As Long

If bFilterLines Then sText = Replace(sText, vbNewLine, vbNullString)
xMax = Len(sText)

For X = 1 To xMax

    mChar = Mid(sText, X, 1)

    If IsDelim(mChar) Then mPos = X - (lDone + 1)
    If hdcObject.TextWidth(mLine & mChar) >= lLength Or X = xMax Then
        If mPos = 0 Then mPos = X - (lDone + 1)
        ReDim Preserve mArray(lnCount)
        mArray(lnCount) = RTrim(LTrim(Mid(mLine, 1, mPos)))
        mLine = Mid(mLine, mPos + 1, Len(mLine) - mPos)
        lDone = lDone + mPos: mPos = 0
        lnCount = lnCount + 1
    End If

    mLine = mLine & mChar

Next X

mArray(lnCount - 1) = mArray(lnCount - 1) & mChar
SplitToLines = mArray

End Function

Public Function IsDelim(Char As String) As Boolean
Select Case Asc(Char)    ' Upper/Lowercase letters,Underscore Not delimiters
Case 65 To 90, 95, 97 To 122
    IsDelim = False
Case Else: IsDelim = True    ' Another Character Is delimiter
End Select
End Function



